<!-- Complete project details: https://randomnerdtutorials.com/esp32-plot-readings-charts-multiple/ -->

<!DOCTYPE html>
<html>
  <head>
    <title>ESP IOT DASHBOARD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="icon" type="image/png" href="favicon.png">
    <link rel="stylesheet" type="text/css" href="style.css">
    <script src="https://code.highcharts.com/highcharts.js"></script>
  <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.8.2/jquery.min.js"></script>
    <!-- Load the MQTT client library -->
 <!-- <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/paho-mqtt/1.0.2/mqttws31.min.js"></script>-->
  <!-- Load an icon library & add the style sheet-->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
   <script src="mqttws31.js" type="text/javascript"></script>

  </head>
  <body>
    <div class="topnav">
      <h1>ESP WEB SERVER CHARTS</h1>
    </div>
    <div class="content">
      <div class="card-grid">
        <div class="card">
          <p class="card-title">Temperature Chart</p>
          <div id="chart-temperature" class="chart-container"></div>
        </div>
      </div>
    </div>
	
    <script> 
    var MQTTbroker = '192.168.8.111';
    var MQTTport = 9001;
    var MQTTsubTopic = 'juliesundar/codettes/01'; //works with wildcard # and + topics dynamically now
    var chart; // global variuable for chart
    var dataTopics = new Array();
    //mqtt broker
    var client = new Paho.MQTT.Client(MQTTbroker, MQTTport,"myclientid_" + parseInt(Math.random() * 100, 10));
      client.onMessageArrived = onMessageArrived;
      client.onConnectionLost = onConnectionLost;
      //mqtt connecton options including the mqtt broker subscriptions
      var options = {
      timeout: 3,
      onSuccess: function () {
        console.log("mqtt connected");
        // Connection succeeded; subscribe to our topics
        client.subscribe(MQTTsubTopic, {qos: 1});
      },
      onFailure: function (message) {
        console.log("Connection failed, ERROR: " + message.errorMessage);
        //window.setTimeout(location.reload(),20000); //wait 20seconds before trying to connect again.
      }
    };
  //can be used to reconnect on connection lost
    function onConnectionLost(responseObject) {
      console.log("connection lost: " + responseObject.errorMessage);
      //window.setTimeout(location.reload(),20000); //wait 20seconds before trying to connect again.
    };

  //what is done when a message arrives from the broker
    //var sensorData = [];
    function onMessageArrived(message) {
      console.log(message.destinationName, '',message.payloadString);
      var messageObj = JSON.parse(message.payloadString);
      myChart.addChartData(messageObj)
    }

      // Create Temperature Chart
      var myChart = new Highcharts.Chart({
        chart:{
          renderTo:'chart-temperature'
        },
        series: [
          {
            name: 'Temp',
            type: 'line',
            color: '#101D42',
            marker: {
              symbol: 'circle',
              radius: 3,
              fillColor: '#101D42',
            }
          },
          {
            name: 'Pressure',
            type: 'line',
            color: '#00A6A6',
            marker: {
              symbol: 'square',
              radius: 3,
              fillColor: '#00A6A6',
            }
          },
          {
            name: 'Altitude',
            type: 'line',
            color: '#8B2635',
            marker: {
              symbol: 'triangle',
              radius: 3,
              fillColor: '#8B2635',
            }
          },
          {
            name: 'Humidity',
            type: 'line',
            color: '#71B48D',
            marker: {
              symbol: 'triangle-down',
              radius: 3,
              fillColor: '#71B48D',
            }
          },
          {
            name: 'Dewpoint',
            type: 'line',
            color: '#44B48D',
            marker: {
              symbol: 'triangle-down',
              radius: 3,
              fillColor: '#71B48D',
            }
          },
        ],
        title: {
          text: undefined
        },
        xAxis: {
          type: 'datetime',
          dateTimeLabelFormats: { second: '%H:%M:%S' }
        },
        yAxis: {
          title: {
            text: 'Temperature Celsius Degrees'
          }
        },
        credits: {
          enabled: false
        }
      });


//Add data to Chart
function addChartData(jsonValue) {

  var keys = Object.keys(jsonValue);
  console.log(keys);
  console.log(keys.length);

  for (var i = 0; i < keys.length; i++){
    var x = (new Date()).getTime();
    console.log(x);
    const key = keys[i];
    var y = Number(jsonValue[key]);
    console.log(y);

    if(myChart.series[i].data.length > 40) {
      myChart.series[i].addPoint([x, y], true, true, true);
    } else {
      myChart.series[i].addPoint([x, y], true, false, true);
    }

  }
}
    </script>
  </body onload="init();">
</html>